﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using System.Net;

namespace UDP_Server_socket
{
    class Program
    {
        static void Main(string[] args)
        {
            byte[] buffer = new byte[4096];//4kb buffer

            try
            {

                Console.WriteLine("Server is running");
                Console.WriteLine("Waiting for connections...");

                using (Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp))
                {

                    //nacuvanie od vsetkych IP adries
                    IPEndPoint iep = new IPEndPoint(IPAddress.Any, 10123);

                    sock.Bind(iep);
                
                    IPEndPoint sender = new IPEndPoint(IPAddress.Any, 0);
                    EndPoint Remote = (EndPoint)(sender);

                    while (true)
                    {
                        int numberOfBytes = sock.ReceiveFrom(buffer, ref Remote);
                    
                        byte[] formatedBytes = new byte[numberOfBytes];
                        Array.Copy(buffer, formatedBytes, numberOfBytes);

                        //Vypiseme co poslal server
                        Console.WriteLine("Client send : ");
                        Console.WriteLine(ASCIIEncoding.ASCII.GetString(formatedBytes));

                        //Odpoved servera
                        byte[] data = Encoding.ASCII.GetBytes("dakujem za spravicku");
                        sock.SendTo(data, data.Length, SocketFlags.None, Remote);

                    }
                }
            }
            catch (Exception ex1)
            {
                Console.WriteLine(ex1.Message);
            }        

        }
    }
}
